import{S as _n,i as gn,s as vn,e as a,k as f,w as d,t as i,M as wn,c as o,d as r,m as u,a as n,x as c,h as s,b as m,G as t,g as p,y as h,L as xn,q as _,o as g,B as v,v as Tn}from"../chunks/vendor-hf-doc-builder.js";import{I as F}from"../chunks/IconCopyLink-hf-doc-builder.js";import{C as D}from"../chunks/CodeBlock-hf-doc-builder.js";function $n(no){let z,Et,j,U,Je,re,Tr,Ke,$r,qt,Ie,yr,Nt,P,G,We,ae,kr,Ze,br,zt,R,Q,et,oe,Ar,tt,Or,jt,w,Er,rt,qr,Nr,at,zr,jr,ot,Pr,Rr,Pt,x,Cr,ne,nt,Ir,Xr,ie,it,Hr,Sr,st,Mr,Fr,Rt,se,Ct,Xe,Dr,It,le,Xt,$,Ur,lt,Gr,Qr,mt,Vr,Yr,Ht,me,St,y,Lr,pe,Br,Jr,fe,Kr,Wr,Mt,C,V,pt,ue,Zr,ft,ea,Ft,T,ta,ut,ra,aa,dt,oa,na,ct,ia,sa,Dt,de,Ut,k,la,ce,ma,pa,he,fa,ua,Gt,I,Y,ht,_e,da,_t,ca,Qt,X,L,gt,ge,ha,vt,_a,Vt,b,ga,wt,va,wa,ve,xa,Ta,Yt,we,Lt,A,$a,xe,ya,ka,Te,ba,Aa,Bt,H,B,xt,$e,Oa,Tt,Ea,Jt,O,qa,$t,Na,za,ye,ja,Pa,Kt,ke,Wt,E,Ra,be,Ca,Ia,Ae,Xa,Ha,Zt,S,J,yt,Oe,Sa,kt,Ma,er,q,Fa,bt,Da,Ua,Ee,Ga,Qa,tr,qe,rr,N,Va,Ne,Ya,La,ze,Ba,Ja,ar,M,K,At,je,Ka,Ot,Wa,or,He,Za,nr,Se,eo,ir,Pe,sr,Me,to,lr,Re,mr,W,ro,Ce,ao,oo,pr;return re=new F({}),ae=new F({}),oe=new F({}),se=new D({props:{code:`from optimum.onnxruntime import ORTModelForSequenceClassification
from transformers import AutoTokenizer

model_checkpoint = "distilbert-base-uncased-finetuned-sst-2-english"
save_directory = "tmp/onnx/"
# Load a model from transformers and export it to ONNX
tokenizer = AutoTokenizer.from_pretrained(model_checkpoint)
ort_model = ORTModelForSequenceClassification.from_pretrained(model_checkpoint, from_transformers=True)
# Save the ONNX model and tokenizer
ort_model.save_pretrained(save_directory)
tokenizer.save_pretrained(save_directory)`,highlighted:`<span class="hljs-keyword">from</span> optimum.onnxruntime <span class="hljs-keyword">import</span> ORTModelForSequenceClassification
<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer

model_checkpoint = <span class="hljs-string">&quot;distilbert-base-uncased-finetuned-sst-2-english&quot;</span>
save_directory = <span class="hljs-string">&quot;tmp/onnx/&quot;</span>
<span class="hljs-comment"># Load a model from transformers and export it to ONNX</span>
tokenizer = AutoTokenizer.from_pretrained(model_checkpoint)
ort_model = ORTModelForSequenceClassification.from_pretrained(model_checkpoint, from_transformers=<span class="hljs-literal">True</span>)
<span class="hljs-comment"># Save the ONNX model and tokenizer</span>
ort_model.save_pretrained(save_directory)
tokenizer.save_pretrained(save_directory)`}}),le=new D({props:{code:`from optimum.onnxruntime.configuration import AutoQuantizationConfig
from optimum.onnxruntime import ORTQuantizer

# Define the quantization methodology
qconfig = AutoQuantizationConfig.arm64(is_static=False, per_channel=False)
quantizer = ORTQuantizer.from_pretrained(ort_model)
# Apply dynamic quantization on the model
quantizer.quantize(save_dir=save_directory, quantization_config=qconfig)`,highlighted:`<span class="hljs-keyword">from</span> optimum.onnxruntime.configuration <span class="hljs-keyword">import</span> AutoQuantizationConfig
<span class="hljs-keyword">from</span> optimum.onnxruntime <span class="hljs-keyword">import</span> ORTQuantizer

<span class="hljs-comment"># Define the quantization methodology</span>
qconfig = AutoQuantizationConfig.arm64(is_static=<span class="hljs-literal">False</span>, per_channel=<span class="hljs-literal">False</span>)
quantizer = ORTQuantizer.from_pretrained(ort_model)
<span class="hljs-comment"># Apply dynamic quantization on the model</span>
quantizer.quantize(save_dir=save_directory, quantization_config=qconfig)`}}),me=new D({props:{code:`from optimum.onnxruntime import ORTModelForSequenceClassification
from transformers import pipeline, AutoTokenizer

model = ORTModelForSequenceClassification.from_pretrained(save_directory, file_name="model_quantized.onnx")
tokenizer = AutoTokenizer.from_pretrained(save_directory)
classifier = pipeline("text-classification", model=model, tokenizer=tokenizer)
results = classifier("I love burritos!")`,highlighted:`<span class="hljs-keyword">from</span> optimum.onnxruntime <span class="hljs-keyword">import</span> ORTModelForSequenceClassification
<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> pipeline, AutoTokenizer

model = ORTModelForSequenceClassification.from_pretrained(save_directory, file_name=<span class="hljs-string">&quot;model_quantized.onnx&quot;</span>)
tokenizer = AutoTokenizer.from_pretrained(save_directory)
classifier = pipeline(<span class="hljs-string">&quot;text-classification&quot;</span>, model=model, tokenizer=tokenizer)
results = classifier(<span class="hljs-string">&quot;I love burritos!&quot;</span>)`}}),ue=new F({}),de=new D({props:{code:`- from transformers import AutoModelForSequenceClassification
+ from optimum.intel.openvino import OVModelForSequenceClassification
  from transformers import AutoTokenizer, pipeline

  # Download a tokenizer and model from the Hub and convert to OpenVINO format
  tokenizer = AutoTokenizer.from_pretrained(model_id)
  model_id = "distilbert-base-uncased-finetuned-sst-2-english"
- model = AutoModelForSequenceClassification.from_pretrained(model_id)
+ model = OVModelForSequenceClassification.from_pretrained(model_id, from_transformers=True)

  # Run inference!
  classifier = pipeline("text-classification", model=model, tokenizer=tokenizer)
  results = classifier("He's a dreadful magician.")`,highlighted:`<span class="hljs-deletion">- from transformers import AutoModelForSequenceClassification</span>
<span class="hljs-addition">+ from optimum.intel.openvino import OVModelForSequenceClassification</span>
  from transformers import AutoTokenizer, pipeline

  # Download a tokenizer and model from the Hub and convert to OpenVINO format
  tokenizer = AutoTokenizer.from_pretrained(model_id)
  model_id = &quot;distilbert-base-uncased-finetuned-sst-2-english&quot;
<span class="hljs-deletion">- model = AutoModelForSequenceClassification.from_pretrained(model_id)</span>
<span class="hljs-addition">+ model = OVModelForSequenceClassification.from_pretrained(model_id, from_transformers=True)</span>

  # Run inference!
  classifier = pipeline(&quot;text-classification&quot;, model=model, tokenizer=tokenizer)
  results = classifier(&quot;He&#x27;s a dreadful magician.&quot;)`}}),_e=new F({}),ge=new F({}),we=new D({props:{code:`- from transformers import Trainer, TrainingArguments
+ from optimum.habana import GaudiTrainer, GaudiTrainingArguments

  # Download a pretrained model from the Hub
  model = AutoModelForXxx.from_pretrained("bert-base-uncased")

  # Define the training arguments
- training_args = TrainingArguments(
+ training_args = GaudiTrainingArguments(
      output_dir="path/to/save/folder/",
+     use_habana=True,
+     use_lazy_mode=True,
+     gaudi_config_name="Habana/bert-base-uncased",
      ...
  )

  # Initialize the trainer
- trainer = Trainer(
+ trainer = GaudiTrainer(
      model=model,
      args=training_args,
      train_dataset=train_dataset,
      ...
  )

  # Use Habana Gaudi processor for training!
  trainer.train()`,highlighted:`<span class="hljs-deletion">- from transformers import Trainer, TrainingArguments</span>
<span class="hljs-addition">+ from optimum.habana import GaudiTrainer, GaudiTrainingArguments</span>

  # Download a pretrained model from the Hub
  model = AutoModelForXxx.from_pretrained(&quot;bert-base-uncased&quot;)

  # Define the training arguments
<span class="hljs-deletion">- training_args = TrainingArguments(</span>
<span class="hljs-addition">+ training_args = GaudiTrainingArguments(</span>
      output_dir=&quot;path/to/save/folder/&quot;,
<span class="hljs-addition">+     use_habana=True,</span>
<span class="hljs-addition">+     use_lazy_mode=True,</span>
<span class="hljs-addition">+     gaudi_config_name=&quot;Habana/bert-base-uncased&quot;,</span>
      ...
  )

  # Initialize the trainer
<span class="hljs-deletion">- trainer = Trainer(</span>
<span class="hljs-addition">+ trainer = GaudiTrainer(</span>
      model=model,
      args=training_args,
      train_dataset=train_dataset,
      ...
  )

  # Use Habana Gaudi processor for training!
  trainer.train()`}}),$e=new F({}),ke=new D({props:{code:`- from transformers import Trainer, TrainingArguments
+ from optimum.graphcore import IPUConfig, IPUTrainer, IPUTrainingArguments

  # Download a pretrained model from the Hub
  model = AutoModelForXxx.from_pretrained("bert-base-uncased")

  # Define the training arguments
- training_args = TrainingArguments(
+ training_args = IPUTrainingArguments(
      output_dir="path/to/save/folder/",
+     ipu_config_name="Graphcore/bert-base-ipu", # Any IPUConfig on the Hub or stored locally
      ...
  )

  # Define the configuration to compile and put the model on the IPU
+ ipu_config = IPUConfig.from_pretrained(training_args.ipu_config_name)

  # Initialize the trainer
- trainer = Trainer(
+ trainer = IPUTrainer(
      model=model,
+     ipu_config=ipu_config
      args=training_args,
      train_dataset=train_dataset
      ...
  )

  # Use Graphcore IPU for training!
  trainer.train()`,highlighted:`<span class="hljs-deletion">- from transformers import Trainer, TrainingArguments</span>
<span class="hljs-addition">+ from optimum.graphcore import IPUConfig, IPUTrainer, IPUTrainingArguments</span>

  # Download a pretrained model from the Hub
  model = AutoModelForXxx.from_pretrained(&quot;bert-base-uncased&quot;)

  # Define the training arguments
<span class="hljs-deletion">- training_args = TrainingArguments(</span>
<span class="hljs-addition">+ training_args = IPUTrainingArguments(</span>
      output_dir=&quot;path/to/save/folder/&quot;,
<span class="hljs-addition">+     ipu_config_name=&quot;Graphcore/bert-base-ipu&quot;, # Any IPUConfig on the Hub or stored locally</span>
      ...
  )

  # Define the configuration to compile and put the model on the IPU
<span class="hljs-addition">+ ipu_config = IPUConfig.from_pretrained(training_args.ipu_config_name)</span>

  # Initialize the trainer
<span class="hljs-deletion">- trainer = Trainer(</span>
<span class="hljs-addition">+ trainer = IPUTrainer(</span>
      model=model,
<span class="hljs-addition">+     ipu_config=ipu_config</span>
      args=training_args,
      train_dataset=train_dataset
      ...
  )

  # Use Graphcore IPU for training!
  trainer.train()`}}),Oe=new F({}),qe=new D({props:{code:`- from transformers import Trainer, TrainingArguments
+ from optimum.onnxruntime import ORTTrainer, ORTTrainingArguments

  # Download a pretrained model from the Hub
  model = AutoModelForSequenceClassification.from_pretrained("bert-base-uncased")

  # Define the training arguments
- training_args = TrainingArguments(
+ training_args = ORTTrainingArguments(
      output_dir="path/to/save/folder/",
      optim="adamw_ort_fused",
      ...
  )

  # Create a ONNX Runtime Trainer
- trainer = Trainer(
+ trainer = ORTTrainer(
      model=model,
      args=training_args,
      train_dataset=train_dataset,
+     feature="sequence-classification", # The model type to export to ONNX
      ...
  )

  # Use ONNX Runtime for training!
  trainer.train()`,highlighted:`<span class="hljs-deletion">- from transformers import Trainer, TrainingArguments</span>
<span class="hljs-addition">+ from optimum.onnxruntime import ORTTrainer, ORTTrainingArguments</span>

  # Download a pretrained model from the Hub
  model = AutoModelForSequenceClassification.from_pretrained(&quot;bert-base-uncased&quot;)

  # Define the training arguments
<span class="hljs-deletion">- training_args = TrainingArguments(</span>
<span class="hljs-addition">+ training_args = ORTTrainingArguments(</span>
      output_dir=&quot;path/to/save/folder/&quot;,
      optim=&quot;adamw_ort_fused&quot;,
      ...
  )

  # Create a ONNX Runtime Trainer
<span class="hljs-deletion">- trainer = Trainer(</span>
<span class="hljs-addition">+ trainer = ORTTrainer(</span>
      model=model,
      args=training_args,
      train_dataset=train_dataset,
<span class="hljs-addition">+     feature=&quot;sequence-classification&quot;, # The model type to export to ONNX</span>
      ...
  )

  # Use ONNX Runtime for training!
  trainer.train()`}}),je=new F({}),Pe=new D({props:{code:"optimum-cli export onnx --model gpt2 gpt2_onnx/",highlighted:'<span class="hljs-title">optimum</span>-cli ex<span class="hljs-keyword">port</span> onnx <span class="hljs-comment">--model gpt2 gpt2_onnx/</span>'}}),Re=new D({props:{code:"optimum-cli export onnx --help",highlighted:'<span class="hljs-title">optimum</span>-cli ex<span class="hljs-keyword">port</span> onnx <span class="hljs-comment">--help</span>'}}),{c(){z=a("meta"),Et=f(),j=a("h1"),U=a("a"),Je=a("span"),d(re.$$.fragment),Tr=f(),Ke=a("span"),$r=i("Quick tour"),qt=f(),Ie=a("p"),yr=i("This quick tour is intended for developers who are ready to dive into the code and see examples of how to integrate \u{1F917} Optimum into their model training and inference workflows."),Nt=f(),P=a("h2"),G=a("a"),We=a("span"),d(ae.$$.fragment),kr=f(),Ze=a("span"),br=i("Accelerated inference"),zt=f(),R=a("h4"),Q=a("a"),et=a("span"),d(oe.$$.fragment),Ar=f(),tt=a("span"),Or=i("ONNX Runtime"),jt=f(),w=a("p"),Er=i("To accelerate inference with ONNX Runtime, \u{1F917} Optimum uses "),rt=a("em"),qr=i("configuration objects"),Nr=i(" to define parameters for graph optimization and quantization. These objects are then used to instantiate dedicated "),at=a("em"),zr=i("optimizers"),jr=i(" and "),ot=a("em"),Pr=i("quantizers"),Rr=i("."),Pt=f(),x=a("p"),Cr=i("Before applying quantization or optimization, first we need to load our model. To load a model and run inference with ONNX Runtime, you can just replace the canonical Transformers "),ne=a("a"),nt=a("code"),Ir=i("AutoModelForXxx"),Xr=i(" class with the corresponding "),ie=a("a"),it=a("code"),Hr=i("ORTModelForXxx"),Sr=i(" class. If you want to load from a PyTorch checkpoint, set "),st=a("code"),Mr=i("from_transformers=True"),Fr=i(" to export your model to the ONNX format."),Rt=f(),d(se.$$.fragment),Ct=f(),Xe=a("p"),Dr=i("Let\u2019s see now how we can apply dynamic quantization with ONNX Runtime:"),It=f(),d(le.$$.fragment),Xt=f(),$=a("p"),Ur=i("In this example, we\u2019ve quantized a model from the Hugging Face Hub, in the same manner we can quantize a model hosted locally by providing the path to the directory containing the model weights. The result from applying the "),lt=a("code"),Gr=i("quantize()"),Qr=i(" method is a "),mt=a("code"),Vr=i("model_quantized.onnx"),Yr=i(" file that can be used to run inference. Here\u2019s an example of how to load an ONNX Runtime model and generate predictions with it:"),Ht=f(),d(me.$$.fragment),St=f(),y=a("p"),Lr=i("You can find more examples in the "),pe=a("a"),Br=i("documentation"),Jr=i(" and in the "),fe=a("a"),Kr=i("examples"),Wr=i("."),Mt=f(),C=a("h4"),V=a("a"),pt=a("span"),d(ue.$$.fragment),Zr=f(),ft=a("span"),ea=i("Intel"),Ft=f(),T=a("p"),ta=i("To load a model and run inference with OpenVINO Runtime, you can just replace your "),ut=a("code"),ra=i("AutoModelForXxx"),aa=i(" class with the corresponding "),dt=a("code"),oa=i("OVModelForXxx"),na=i(` class.
If you want to load a PyTorch checkpoint, set `),ct=a("code"),ia=i("from_transformers=True"),sa=i(" to convert your model to the OpenVINO IR (Intermediate Representation)."),Dt=f(),d(de.$$.fragment),Ut=f(),k=a("p"),la=i("You can find more examples in the "),ce=a("a"),ma=i("documentation"),pa=i(" and in the "),he=a("a"),fa=i("examples"),ua=i("."),Gt=f(),I=a("h2"),Y=a("a"),ht=a("span"),d(_e.$$.fragment),da=f(),_t=a("span"),ca=i("Accelerated training"),Qt=f(),X=a("h4"),L=a("a"),gt=a("span"),d(ge.$$.fragment),ha=f(),vt=a("span"),_a=i("Habana"),Vt=f(),b=a("p"),ga=i("To train transformers on Habana\u2019s Gaudi processors, \u{1F917} Optimum provides a "),wt=a("code"),va=i("GaudiTrainer"),wa=i(" that is very similar to the \u{1F917} Transformers "),ve=a("a"),xa=i("Trainer"),Ta=i(". Here is a simple example:"),Yt=f(),d(we.$$.fragment),Lt=f(),A=a("p"),$a=i("You can find more examples in the "),xe=a("a"),ya=i("documentation"),ka=i(" and in the "),Te=a("a"),ba=i("examples"),Aa=i("."),Bt=f(),H=a("h4"),B=a("a"),xt=a("span"),d($e.$$.fragment),Oa=f(),Tt=a("span"),Ea=i("Graphcore"),Jt=f(),O=a("p"),qa=i("To train transformers on Graphcore\u2019s IPUs, \u{1F917} Optimum provides a "),$t=a("code"),Na=i("IPUTrainer"),za=i(" that is very similar to the \u{1F917} Transformers "),ye=a("a"),ja=i("Trainer"),Pa=i(". Here is a simple example:"),Kt=f(),d(ke.$$.fragment),Wt=f(),E=a("p"),Ra=i("You can find more examples in the "),be=a("a"),Ca=i("documentation"),Ia=i(" and in the "),Ae=a("a"),Xa=i("examples"),Ha=i("."),Zt=f(),S=a("h4"),J=a("a"),yt=a("span"),d(Oe.$$.fragment),Sa=f(),kt=a("span"),Ma=i("ONNX Runtime"),er=f(),q=a("p"),Fa=i("To train transformers with ONNX Runtime\u2019s acceleration features, \u{1F917} Optimum provides a "),bt=a("code"),Da=i("ORTTrainer"),Ua=i(" that is very similar to the \u{1F917} Transformers "),Ee=a("a"),Ga=i("Trainer"),Qa=i(". Here is a simple example:"),tr=f(),d(qe.$$.fragment),rr=f(),N=a("p"),Va=i("You can find more examples in the "),Ne=a("a"),Ya=i("documentation"),La=i(" and in the "),ze=a("a"),Ba=i("examples"),Ja=i("."),ar=f(),M=a("h2"),K=a("a"),At=a("span"),d(je.$$.fragment),Ka=f(),Ot=a("span"),Wa=i("Out of the box ONNX export"),or=f(),He=a("p"),Za=i("The Optimum library handles out of the box the ONNX export of Transformers and Diffusers models!"),nr=f(),Se=a("p"),eo=i("Exporting a model to ONNX is as simple as"),ir=f(),d(Pe.$$.fragment),sr=f(),Me=a("p"),to=i("Check out the help for more options:"),lr=f(),d(Re.$$.fragment),mr=f(),W=a("p"),ro=i("Check out the "),Ce=a("a"),ao=i("documentation"),oo=i(" for more."),this.h()},l(e){const l=wn('[data-svelte="svelte-1phssyn"]',document.head);z=o(l,"META",{name:!0,content:!0}),l.forEach(r),Et=u(e),j=o(e,"H1",{class:!0});var fr=n(j);U=o(fr,"A",{id:!0,class:!0,href:!0});var io=n(U);Je=o(io,"SPAN",{});var so=n(Je);c(re.$$.fragment,so),so.forEach(r),io.forEach(r),Tr=u(fr),Ke=o(fr,"SPAN",{});var lo=n(Ke);$r=s(lo,"Quick tour"),lo.forEach(r),fr.forEach(r),qt=u(e),Ie=o(e,"P",{});var mo=n(Ie);yr=s(mo,"This quick tour is intended for developers who are ready to dive into the code and see examples of how to integrate \u{1F917} Optimum into their model training and inference workflows."),mo.forEach(r),Nt=u(e),P=o(e,"H2",{class:!0});var ur=n(P);G=o(ur,"A",{id:!0,class:!0,href:!0});var po=n(G);We=o(po,"SPAN",{});var fo=n(We);c(ae.$$.fragment,fo),fo.forEach(r),po.forEach(r),kr=u(ur),Ze=o(ur,"SPAN",{});var uo=n(Ze);br=s(uo,"Accelerated inference"),uo.forEach(r),ur.forEach(r),zt=u(e),R=o(e,"H4",{class:!0});var dr=n(R);Q=o(dr,"A",{id:!0,class:!0,href:!0});var co=n(Q);et=o(co,"SPAN",{});var ho=n(et);c(oe.$$.fragment,ho),ho.forEach(r),co.forEach(r),Ar=u(dr),tt=o(dr,"SPAN",{});var _o=n(tt);Or=s(_o,"ONNX Runtime"),_o.forEach(r),dr.forEach(r),jt=u(e),w=o(e,"P",{});var Z=n(w);Er=s(Z,"To accelerate inference with ONNX Runtime, \u{1F917} Optimum uses "),rt=o(Z,"EM",{});var go=n(rt);qr=s(go,"configuration objects"),go.forEach(r),Nr=s(Z," to define parameters for graph optimization and quantization. These objects are then used to instantiate dedicated "),at=o(Z,"EM",{});var vo=n(at);zr=s(vo,"optimizers"),vo.forEach(r),jr=s(Z," and "),ot=o(Z,"EM",{});var wo=n(ot);Pr=s(wo,"quantizers"),wo.forEach(r),Rr=s(Z,"."),Z.forEach(r),Pt=u(e),x=o(e,"P",{});var ee=n(x);Cr=s(ee,"Before applying quantization or optimization, first we need to load our model. To load a model and run inference with ONNX Runtime, you can just replace the canonical Transformers "),ne=o(ee,"A",{href:!0,rel:!0});var xo=n(ne);nt=o(xo,"CODE",{});var To=n(nt);Ir=s(To,"AutoModelForXxx"),To.forEach(r),xo.forEach(r),Xr=s(ee," class with the corresponding "),ie=o(ee,"A",{href:!0,rel:!0});var $o=n(ie);it=o($o,"CODE",{});var yo=n(it);Hr=s(yo,"ORTModelForXxx"),yo.forEach(r),$o.forEach(r),Sr=s(ee," class. If you want to load from a PyTorch checkpoint, set "),st=o(ee,"CODE",{});var ko=n(st);Mr=s(ko,"from_transformers=True"),ko.forEach(r),Fr=s(ee," to export your model to the ONNX format."),ee.forEach(r),Rt=u(e),c(se.$$.fragment,e),Ct=u(e),Xe=o(e,"P",{});var bo=n(Xe);Dr=s(bo,"Let\u2019s see now how we can apply dynamic quantization with ONNX Runtime:"),bo.forEach(r),It=u(e),c(le.$$.fragment,e),Xt=u(e),$=o(e,"P",{});var Fe=n($);Ur=s(Fe,"In this example, we\u2019ve quantized a model from the Hugging Face Hub, in the same manner we can quantize a model hosted locally by providing the path to the directory containing the model weights. The result from applying the "),lt=o(Fe,"CODE",{});var Ao=n(lt);Gr=s(Ao,"quantize()"),Ao.forEach(r),Qr=s(Fe," method is a "),mt=o(Fe,"CODE",{});var Oo=n(mt);Vr=s(Oo,"model_quantized.onnx"),Oo.forEach(r),Yr=s(Fe," file that can be used to run inference. Here\u2019s an example of how to load an ONNX Runtime model and generate predictions with it:"),Fe.forEach(r),Ht=u(e),c(me.$$.fragment,e),St=u(e),y=o(e,"P",{});var De=n(y);Lr=s(De,"You can find more examples in the "),pe=o(De,"A",{href:!0,rel:!0});var Eo=n(pe);Br=s(Eo,"documentation"),Eo.forEach(r),Jr=s(De," and in the "),fe=o(De,"A",{href:!0,rel:!0});var qo=n(fe);Kr=s(qo,"examples"),qo.forEach(r),Wr=s(De,"."),De.forEach(r),Mt=u(e),C=o(e,"H4",{class:!0});var cr=n(C);V=o(cr,"A",{id:!0,class:!0,href:!0});var No=n(V);pt=o(No,"SPAN",{});var zo=n(pt);c(ue.$$.fragment,zo),zo.forEach(r),No.forEach(r),Zr=u(cr),ft=o(cr,"SPAN",{});var jo=n(ft);ea=s(jo,"Intel"),jo.forEach(r),cr.forEach(r),Ft=u(e),T=o(e,"P",{});var te=n(T);ta=s(te,"To load a model and run inference with OpenVINO Runtime, you can just replace your "),ut=o(te,"CODE",{});var Po=n(ut);ra=s(Po,"AutoModelForXxx"),Po.forEach(r),aa=s(te," class with the corresponding "),dt=o(te,"CODE",{});var Ro=n(dt);oa=s(Ro,"OVModelForXxx"),Ro.forEach(r),na=s(te,` class.
If you want to load a PyTorch checkpoint, set `),ct=o(te,"CODE",{});var Co=n(ct);ia=s(Co,"from_transformers=True"),Co.forEach(r),sa=s(te," to convert your model to the OpenVINO IR (Intermediate Representation)."),te.forEach(r),Dt=u(e),c(de.$$.fragment,e),Ut=u(e),k=o(e,"P",{});var Ue=n(k);la=s(Ue,"You can find more examples in the "),ce=o(Ue,"A",{href:!0,rel:!0});var Io=n(ce);ma=s(Io,"documentation"),Io.forEach(r),pa=s(Ue," and in the "),he=o(Ue,"A",{href:!0,rel:!0});var Xo=n(he);fa=s(Xo,"examples"),Xo.forEach(r),ua=s(Ue,"."),Ue.forEach(r),Gt=u(e),I=o(e,"H2",{class:!0});var hr=n(I);Y=o(hr,"A",{id:!0,class:!0,href:!0});var Ho=n(Y);ht=o(Ho,"SPAN",{});var So=n(ht);c(_e.$$.fragment,So),So.forEach(r),Ho.forEach(r),da=u(hr),_t=o(hr,"SPAN",{});var Mo=n(_t);ca=s(Mo,"Accelerated training"),Mo.forEach(r),hr.forEach(r),Qt=u(e),X=o(e,"H4",{class:!0});var _r=n(X);L=o(_r,"A",{id:!0,class:!0,href:!0});var Fo=n(L);gt=o(Fo,"SPAN",{});var Do=n(gt);c(ge.$$.fragment,Do),Do.forEach(r),Fo.forEach(r),ha=u(_r),vt=o(_r,"SPAN",{});var Uo=n(vt);_a=s(Uo,"Habana"),Uo.forEach(r),_r.forEach(r),Vt=u(e),b=o(e,"P",{});var Ge=n(b);ga=s(Ge,"To train transformers on Habana\u2019s Gaudi processors, \u{1F917} Optimum provides a "),wt=o(Ge,"CODE",{});var Go=n(wt);va=s(Go,"GaudiTrainer"),Go.forEach(r),wa=s(Ge," that is very similar to the \u{1F917} Transformers "),ve=o(Ge,"A",{href:!0,rel:!0});var Qo=n(ve);xa=s(Qo,"Trainer"),Qo.forEach(r),Ta=s(Ge,". Here is a simple example:"),Ge.forEach(r),Yt=u(e),c(we.$$.fragment,e),Lt=u(e),A=o(e,"P",{});var Qe=n(A);$a=s(Qe,"You can find more examples in the "),xe=o(Qe,"A",{href:!0,rel:!0});var Vo=n(xe);ya=s(Vo,"documentation"),Vo.forEach(r),ka=s(Qe," and in the "),Te=o(Qe,"A",{href:!0,rel:!0});var Yo=n(Te);ba=s(Yo,"examples"),Yo.forEach(r),Aa=s(Qe,"."),Qe.forEach(r),Bt=u(e),H=o(e,"H4",{class:!0});var gr=n(H);B=o(gr,"A",{id:!0,class:!0,href:!0});var Lo=n(B);xt=o(Lo,"SPAN",{});var Bo=n(xt);c($e.$$.fragment,Bo),Bo.forEach(r),Lo.forEach(r),Oa=u(gr),Tt=o(gr,"SPAN",{});var Jo=n(Tt);Ea=s(Jo,"Graphcore"),Jo.forEach(r),gr.forEach(r),Jt=u(e),O=o(e,"P",{});var Ve=n(O);qa=s(Ve,"To train transformers on Graphcore\u2019s IPUs, \u{1F917} Optimum provides a "),$t=o(Ve,"CODE",{});var Ko=n($t);Na=s(Ko,"IPUTrainer"),Ko.forEach(r),za=s(Ve," that is very similar to the \u{1F917} Transformers "),ye=o(Ve,"A",{href:!0,rel:!0});var Wo=n(ye);ja=s(Wo,"Trainer"),Wo.forEach(r),Pa=s(Ve,". Here is a simple example:"),Ve.forEach(r),Kt=u(e),c(ke.$$.fragment,e),Wt=u(e),E=o(e,"P",{});var Ye=n(E);Ra=s(Ye,"You can find more examples in the "),be=o(Ye,"A",{href:!0,rel:!0});var Zo=n(be);Ca=s(Zo,"documentation"),Zo.forEach(r),Ia=s(Ye," and in the "),Ae=o(Ye,"A",{href:!0,rel:!0});var en=n(Ae);Xa=s(en,"examples"),en.forEach(r),Ha=s(Ye,"."),Ye.forEach(r),Zt=u(e),S=o(e,"H4",{class:!0});var vr=n(S);J=o(vr,"A",{id:!0,class:!0,href:!0});var tn=n(J);yt=o(tn,"SPAN",{});var rn=n(yt);c(Oe.$$.fragment,rn),rn.forEach(r),tn.forEach(r),Sa=u(vr),kt=o(vr,"SPAN",{});var an=n(kt);Ma=s(an,"ONNX Runtime"),an.forEach(r),vr.forEach(r),er=u(e),q=o(e,"P",{});var Le=n(q);Fa=s(Le,"To train transformers with ONNX Runtime\u2019s acceleration features, \u{1F917} Optimum provides a "),bt=o(Le,"CODE",{});var on=n(bt);Da=s(on,"ORTTrainer"),on.forEach(r),Ua=s(Le," that is very similar to the \u{1F917} Transformers "),Ee=o(Le,"A",{href:!0,rel:!0});var nn=n(Ee);Ga=s(nn,"Trainer"),nn.forEach(r),Qa=s(Le,". Here is a simple example:"),Le.forEach(r),tr=u(e),c(qe.$$.fragment,e),rr=u(e),N=o(e,"P",{});var Be=n(N);Va=s(Be,"You can find more examples in the "),Ne=o(Be,"A",{href:!0,rel:!0});var sn=n(Ne);Ya=s(sn,"documentation"),sn.forEach(r),La=s(Be," and in the "),ze=o(Be,"A",{href:!0,rel:!0});var ln=n(ze);Ba=s(ln,"examples"),ln.forEach(r),Ja=s(Be,"."),Be.forEach(r),ar=u(e),M=o(e,"H2",{class:!0});var wr=n(M);K=o(wr,"A",{id:!0,class:!0,href:!0});var mn=n(K);At=o(mn,"SPAN",{});var pn=n(At);c(je.$$.fragment,pn),pn.forEach(r),mn.forEach(r),Ka=u(wr),Ot=o(wr,"SPAN",{});var fn=n(Ot);Wa=s(fn,"Out of the box ONNX export"),fn.forEach(r),wr.forEach(r),or=u(e),He=o(e,"P",{});var un=n(He);Za=s(un,"The Optimum library handles out of the box the ONNX export of Transformers and Diffusers models!"),un.forEach(r),nr=u(e),Se=o(e,"P",{});var dn=n(Se);eo=s(dn,"Exporting a model to ONNX is as simple as"),dn.forEach(r),ir=u(e),c(Pe.$$.fragment,e),sr=u(e),Me=o(e,"P",{});var cn=n(Me);to=s(cn,"Check out the help for more options:"),cn.forEach(r),lr=u(e),c(Re.$$.fragment,e),mr=u(e),W=o(e,"P",{});var xr=n(W);ro=s(xr,"Check out the "),Ce=o(xr,"A",{href:!0,rel:!0});var hn=n(Ce);ao=s(hn,"documentation"),hn.forEach(r),oo=s(xr," for more."),xr.forEach(r),this.h()},h(){m(z,"name","hf:doc:metadata"),m(z,"content",JSON.stringify(yn)),m(U,"id","quick-tour"),m(U,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(U,"href","#quick-tour"),m(j,"class","relative group"),m(G,"id","accelerated-inference"),m(G,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(G,"href","#accelerated-inference"),m(P,"class","relative group"),m(Q,"id","onnx-runtime"),m(Q,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(Q,"href","#onnx-runtime"),m(R,"class","relative group"),m(ne,"href","https://huggingface.co/docs/transformers/model_doc/auto#transformers.AutoModel"),m(ne,"rel","nofollow"),m(ie,"href","https://huggingface.co/docs/optimum/onnxruntime/package_reference/modeling_ort#optimum.onnxruntime.ORTModel"),m(ie,"rel","nofollow"),m(pe,"href","https://huggingface.co/docs/optimum/onnxruntime/quickstart"),m(pe,"rel","nofollow"),m(fe,"href","https://github.com/huggingface/optimum/tree/main/examples/onnxruntime"),m(fe,"rel","nofollow"),m(V,"id","intel"),m(V,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(V,"href","#intel"),m(C,"class","relative group"),m(ce,"href","https://huggingface.co/docs/optimum/intel/inference"),m(ce,"rel","nofollow"),m(he,"href","https://github.com/huggingface/optimum-intel/tree/main/examples/openvino"),m(he,"rel","nofollow"),m(Y,"id","accelerated-training"),m(Y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(Y,"href","#accelerated-training"),m(I,"class","relative group"),m(L,"id","habana"),m(L,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(L,"href","#habana"),m(X,"class","relative group"),m(ve,"href","https://huggingface.co/docs/transformers/main_classes/trainer"),m(ve,"rel","nofollow"),m(xe,"href","https://huggingface.co/docs/optimum/habana/quickstart"),m(xe,"rel","nofollow"),m(Te,"href","https://github.com/huggingface/optimum-habana/tree/main/examples"),m(Te,"rel","nofollow"),m(B,"id","graphcore"),m(B,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(B,"href","#graphcore"),m(H,"class","relative group"),m(ye,"href","https://huggingface.co/docs/transformers/main_classes/trainer"),m(ye,"rel","nofollow"),m(be,"href","https://huggingface.co/docs/optimum/graphcore/quickstart"),m(be,"rel","nofollow"),m(Ae,"href","https://github.com/huggingface/optimum-graphcore/tree/main/examples"),m(Ae,"rel","nofollow"),m(J,"id","onnx-runtime"),m(J,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(J,"href","#onnx-runtime"),m(S,"class","relative group"),m(Ee,"href","https://huggingface.co/docs/transformers/main_classes/trainer"),m(Ee,"rel","nofollow"),m(Ne,"href","https://huggingface.co/docs/optimum/onnxruntime/usage_guides/trainer"),m(Ne,"rel","nofollow"),m(ze,"href","https://github.com/huggingface/optimum/tree/main/examples/onnxruntime/training"),m(ze,"rel","nofollow"),m(K,"id","out-of-the-box-onnx-export"),m(K,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(K,"href","#out-of-the-box-onnx-export"),m(M,"class","relative group"),m(Ce,"href","https://huggingface.co/docs/optimum/exporters/onnx/usage_guides/export_a_model"),m(Ce,"rel","nofollow")},m(e,l){t(document.head,z),p(e,Et,l),p(e,j,l),t(j,U),t(U,Je),h(re,Je,null),t(j,Tr),t(j,Ke),t(Ke,$r),p(e,qt,l),p(e,Ie,l),t(Ie,yr),p(e,Nt,l),p(e,P,l),t(P,G),t(G,We),h(ae,We,null),t(P,kr),t(P,Ze),t(Ze,br),p(e,zt,l),p(e,R,l),t(R,Q),t(Q,et),h(oe,et,null),t(R,Ar),t(R,tt),t(tt,Or),p(e,jt,l),p(e,w,l),t(w,Er),t(w,rt),t(rt,qr),t(w,Nr),t(w,at),t(at,zr),t(w,jr),t(w,ot),t(ot,Pr),t(w,Rr),p(e,Pt,l),p(e,x,l),t(x,Cr),t(x,ne),t(ne,nt),t(nt,Ir),t(x,Xr),t(x,ie),t(ie,it),t(it,Hr),t(x,Sr),t(x,st),t(st,Mr),t(x,Fr),p(e,Rt,l),h(se,e,l),p(e,Ct,l),p(e,Xe,l),t(Xe,Dr),p(e,It,l),h(le,e,l),p(e,Xt,l),p(e,$,l),t($,Ur),t($,lt),t(lt,Gr),t($,Qr),t($,mt),t(mt,Vr),t($,Yr),p(e,Ht,l),h(me,e,l),p(e,St,l),p(e,y,l),t(y,Lr),t(y,pe),t(pe,Br),t(y,Jr),t(y,fe),t(fe,Kr),t(y,Wr),p(e,Mt,l),p(e,C,l),t(C,V),t(V,pt),h(ue,pt,null),t(C,Zr),t(C,ft),t(ft,ea),p(e,Ft,l),p(e,T,l),t(T,ta),t(T,ut),t(ut,ra),t(T,aa),t(T,dt),t(dt,oa),t(T,na),t(T,ct),t(ct,ia),t(T,sa),p(e,Dt,l),h(de,e,l),p(e,Ut,l),p(e,k,l),t(k,la),t(k,ce),t(ce,ma),t(k,pa),t(k,he),t(he,fa),t(k,ua),p(e,Gt,l),p(e,I,l),t(I,Y),t(Y,ht),h(_e,ht,null),t(I,da),t(I,_t),t(_t,ca),p(e,Qt,l),p(e,X,l),t(X,L),t(L,gt),h(ge,gt,null),t(X,ha),t(X,vt),t(vt,_a),p(e,Vt,l),p(e,b,l),t(b,ga),t(b,wt),t(wt,va),t(b,wa),t(b,ve),t(ve,xa),t(b,Ta),p(e,Yt,l),h(we,e,l),p(e,Lt,l),p(e,A,l),t(A,$a),t(A,xe),t(xe,ya),t(A,ka),t(A,Te),t(Te,ba),t(A,Aa),p(e,Bt,l),p(e,H,l),t(H,B),t(B,xt),h($e,xt,null),t(H,Oa),t(H,Tt),t(Tt,Ea),p(e,Jt,l),p(e,O,l),t(O,qa),t(O,$t),t($t,Na),t(O,za),t(O,ye),t(ye,ja),t(O,Pa),p(e,Kt,l),h(ke,e,l),p(e,Wt,l),p(e,E,l),t(E,Ra),t(E,be),t(be,Ca),t(E,Ia),t(E,Ae),t(Ae,Xa),t(E,Ha),p(e,Zt,l),p(e,S,l),t(S,J),t(J,yt),h(Oe,yt,null),t(S,Sa),t(S,kt),t(kt,Ma),p(e,er,l),p(e,q,l),t(q,Fa),t(q,bt),t(bt,Da),t(q,Ua),t(q,Ee),t(Ee,Ga),t(q,Qa),p(e,tr,l),h(qe,e,l),p(e,rr,l),p(e,N,l),t(N,Va),t(N,Ne),t(Ne,Ya),t(N,La),t(N,ze),t(ze,Ba),t(N,Ja),p(e,ar,l),p(e,M,l),t(M,K),t(K,At),h(je,At,null),t(M,Ka),t(M,Ot),t(Ot,Wa),p(e,or,l),p(e,He,l),t(He,Za),p(e,nr,l),p(e,Se,l),t(Se,eo),p(e,ir,l),h(Pe,e,l),p(e,sr,l),p(e,Me,l),t(Me,to),p(e,lr,l),h(Re,e,l),p(e,mr,l),p(e,W,l),t(W,ro),t(W,Ce),t(Ce,ao),t(W,oo),pr=!0},p:xn,i(e){pr||(_(re.$$.fragment,e),_(ae.$$.fragment,e),_(oe.$$.fragment,e),_(se.$$.fragment,e),_(le.$$.fragment,e),_(me.$$.fragment,e),_(ue.$$.fragment,e),_(de.$$.fragment,e),_(_e.$$.fragment,e),_(ge.$$.fragment,e),_(we.$$.fragment,e),_($e.$$.fragment,e),_(ke.$$.fragment,e),_(Oe.$$.fragment,e),_(qe.$$.fragment,e),_(je.$$.fragment,e),_(Pe.$$.fragment,e),_(Re.$$.fragment,e),pr=!0)},o(e){g(re.$$.fragment,e),g(ae.$$.fragment,e),g(oe.$$.fragment,e),g(se.$$.fragment,e),g(le.$$.fragment,e),g(me.$$.fragment,e),g(ue.$$.fragment,e),g(de.$$.fragment,e),g(_e.$$.fragment,e),g(ge.$$.fragment,e),g(we.$$.fragment,e),g($e.$$.fragment,e),g(ke.$$.fragment,e),g(Oe.$$.fragment,e),g(qe.$$.fragment,e),g(je.$$.fragment,e),g(Pe.$$.fragment,e),g(Re.$$.fragment,e),pr=!1},d(e){r(z),e&&r(Et),e&&r(j),v(re),e&&r(qt),e&&r(Ie),e&&r(Nt),e&&r(P),v(ae),e&&r(zt),e&&r(R),v(oe),e&&r(jt),e&&r(w),e&&r(Pt),e&&r(x),e&&r(Rt),v(se,e),e&&r(Ct),e&&r(Xe),e&&r(It),v(le,e),e&&r(Xt),e&&r($),e&&r(Ht),v(me,e),e&&r(St),e&&r(y),e&&r(Mt),e&&r(C),v(ue),e&&r(Ft),e&&r(T),e&&r(Dt),v(de,e),e&&r(Ut),e&&r(k),e&&r(Gt),e&&r(I),v(_e),e&&r(Qt),e&&r(X),v(ge),e&&r(Vt),e&&r(b),e&&r(Yt),v(we,e),e&&r(Lt),e&&r(A),e&&r(Bt),e&&r(H),v($e),e&&r(Jt),e&&r(O),e&&r(Kt),v(ke,e),e&&r(Wt),e&&r(E),e&&r(Zt),e&&r(S),v(Oe),e&&r(er),e&&r(q),e&&r(tr),v(qe,e),e&&r(rr),e&&r(N),e&&r(ar),e&&r(M),v(je),e&&r(or),e&&r(He),e&&r(nr),e&&r(Se),e&&r(ir),v(Pe,e),e&&r(sr),e&&r(Me),e&&r(lr),v(Re,e),e&&r(mr),e&&r(W)}}}const yn={local:"quick-tour",sections:[{local:"accelerated-inference",sections:[{local:"onnx-runtime",title:"ONNX Runtime"},{local:"intel",title:"Intel"}],title:"Accelerated inference"},{local:"accelerated-training",sections:[{local:"habana",title:"Habana"},{local:"graphcore",title:"Graphcore"},{local:"onnx-runtime",title:"ONNX Runtime"}],title:"Accelerated training"},{local:"out-of-the-box-onnx-export",title:"Out of the box ONNX export"}],title:"Quick tour"};function kn(no){return Tn(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class En extends _n{constructor(z){super();gn(this,z,kn,$n,vn,{})}}export{En as default,yn as metadata};
